//------------------------------------------------------------------------------
/*
    This file is part of Bottle2D.

    Bottle2D is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Bottle2D is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Bottle2D.  If not, see <http://www.gnu.org/licenses/>.
*/
//------------------------------------------------------------------------------
#ifndef CLASS_WITH_PROTECTED_RC_HPP
#define CLASS_WITH_PROTECTED_RC_HPP
//------------------------------------------------------------------------------
#include "config.hpp"
#include "ProtectedPtr.hpp"
#include <list>
//------------------------------------------------------------------------------
namespace En
{
//------------------------------------------------------------------------------
class ClassWithProtectedRcBase
{
public:
    void CheckResources();
    virtual bool AreResourcesOk() = 0;

protected:

};
//------------------------------------------------------------------------------
class ClassWithProtectedRcSingle : public ClassWithProtectedRcBase
{
public:
    virtual bool AreResourcesOk();

    void SetResource(ProtectedPtr<ProtectedClassBase> rcPtr);
    ProtectedPtr<ProtectedClassBase> GetResource() const;
    void ClearResource();

private:
    ProtectedPtr<ProtectedClassBase> m_ptr;
};
//------------------------------------------------------------------------------
class ClassWithProtectedRcMultiple : public ClassWithProtectedRcBase
{
public:
    virtual bool AreResourcesOk();

    void AddResource(ProtectedPtr<ProtectedClassBase> rcPtr);
    void RemoveResource(ProtectedPtr<ProtectedClassBase> rcPtrToRemove);
    void ClearResources();

private:
    std::list<ProtectedPtr<ProtectedClassBase> > m_ptrList;
};
//------------------------------------------------------------------------------
} // namespace En
//------------------------------------------------------------------------------
#endif // CLASS_WITH_PROTECTED_RC_HPP
