require("guiLib/buttonControl")

keyChoiceCtrl = keyChoiceCtrl or {}

-- Quit fn
function keyChoiceCtrl.create(parentGrp, position, size, msg)
	local bt = parentGrp:CreateGroup("choiceBtGrp")
	
	msg = string.format(_("Please press a key to asign it to \"%s\" or press Escape to cancel."), msg)
	
	bt:SetUserData("msg", msg)
	
	buttonControlCreate(bt, "A", size)
	buttonSetEventFunction(bt, keyChoiceCtrl.privateEvtFn)
	buttonSetFont(bt, 28, Color(255, 255, 255), fontFixedsys)
	buttonSetImagePack(bt, texMenuBtNormal, texMenuBtOver, texMenuBtPressed)
	bt:SetPosition(position)
	
	return bt
end

-- Set key
function keyChoiceCtrl.setKey(grp, key)
	buttonSetLabel(grp, key)
end

-- Get key
function keyChoiceCtrl.getKey(grp)
	return buttonGetLabel(grp)
end


------------------------------------------------------------
-- Private
------------------------------------------------------------

function keyChoiceCtrl.privateEvtFn(grp)
	popupDialog(grp:GetParentScreen(), "dialogAskKey", grp:GetUserData("msg"), keyChoiceCtrl.privateDialogFn, nil, grp)
end

function keyChoiceCtrl.privateDialogFn(answer, grp)	
	if answer ~= nil then
		keyChoiceCtrl.setKey(grp, answer)
	end
end
