------------------------------------------------------------
-- Level 03
------------------------------------------------------------

function initCurrentLevelData()
	levelData = {}
	levelData["back"] = loadTexture("levels/level03.png")
	levelData["removable2"] = loadTexture("removable2.png")
	
	-- background sky
	levelData["backgroundSky"] = loadTexture("sky_pixels.png")
end

function createCurrentLevel(levelGrp)
	-- Back
	local tmp = levelGrp:CreateSprite("backImg")
	tmp:SetImage(levelData["back"])
	tmp:SetZpos(-1000)
	
	-- Sky
	setSkyTexture(levelData["backgroundSky"])

	-- Décors de base
	createWall(levelGrp, Vector2D(7, 6 ), Vector2D(28, 646 ))
	createWall(levelGrp, Vector2D(1072, 6 ), Vector2D(28, 646 ))
	createWall(levelGrp, Vector2D(7, 6 ), Vector2D(1093, 28 ))
	createWall(levelGrp, Vector2D(7, 624 ), Vector2D(1093, 28 ))
	createWall(levelGrp, Vector2D(35, 315 ), Vector2D(745, 28 ))
	createWall(levelGrp, Vector2D(873, 315 ), Vector2D(82, 28 ))
	createWall(levelGrp, Vector2D(1045, 315 ), Vector2D(27, 28 ))
	createWall(levelGrp, Vector2D(330, 120 ), Vector2D(28, 109 ))
	createWall(levelGrp, Vector2D(709, 120 ), Vector2D(28, 109 ))
	createWall(levelGrp, Vector2D(253, 483 ), Vector2D(117, 28 ))
	createWall(levelGrp, Vector2D(721, 483 ), Vector2D(117, 28 ))

	
	--Surfaces perméables perso (3)
	local ph = createWall(levelGrp, Vector2D(330, 229 ), Vector2D(28, 86 ))
	wallEnablePlayerPass(ph, true)
	local ph = createWall(levelGrp, Vector2D(709, 34 ), Vector2D(28, 86 ))
	wallEnablePlayerPass(ph, true)
	local ph = createWall(levelGrp, Vector2D(780, 315 ), Vector2D(93, 28 ))
	wallEnablePlayerPass(ph, true)
	
	
	--Surfaces perméables bombe (3)
	local ph = createWall(levelGrp, Vector2D(330, 34 ), Vector2D(28, 86 ))
	wallEnableBombePass(ph, true)
	local ph = createWall(levelGrp, Vector2D(709, 229 ), Vector2D(28, 86 ))
	wallEnableBombePass(ph, true)
	local ph = createWall(levelGrp, Vector2D(955, 315 ), Vector2D(90, 28 ))
	wallEnableBombePass(ph, true)
	
	--Timer et 1 surface amovible
	local timer = createTimerButton(levelGrp, Vector2D(495, 225), 10, nil)
	local area1 = createRemovableArea(levelGrp, Vector2D(620, 203), Vector2D(117, 28), levelData["removable2"], Vector2D(0, 0))
	createRemovableAreaButton({area1}, timer, false)
	
	--Interrupteur et 2 surfaces amovibles
	local button = createOnOffButton(levelGrp, Vector2D(912, 226), nil)
	local area2 = createRemovableArea(levelGrp, Vector2D(487, 483), Vector2D(117, 28), levelData["removable2"], Vector2D(0, 0))
	local area3 = createRemovableArea(levelGrp, Vector2D(955, 484), Vector2D(117, 28), levelData["removable2"], Vector2D(0, 0))
	createRemovableAreaButton({area2, area3}, button, false)

	-- Piques
	createHurtZone(levelGrp, Vector2D(136, 343 ), Vector2D(117, 28 ), true)
	createHurtZone(levelGrp, Vector2D(253, 597 ), Vector2D(819, 27 ))
	
	--Messages
	createMessageZoneMitraille(levelGrp, Vector2D(49, 269), Vector2D(92, 46), {_("Level 3 - Introduction to the permeable surfaces and the peaks"), _("The blue fiels let only the human pass !"), _("The red fields only let the bomb pass !"), _("Both types of fiels are completely harmless !")}, 1.5)
	-- "Les champs bleus ne laissent passer que les humains !", "Les champs rouges ne laissent passer que la bombe !", "Les deux types de champs sont parfaitement inoffensifs !"
	createMessageZone(levelGrp, Vector2D(753, 449), Vector2D(62, 34), _("Beware of the peaks ! hard jump"))
	-- "Attention aux piques ! Sauts millimétrés"
	
	--Checkpoint Zone
	createCheckpointZone(levelGrp, Vector2D(747, 231), Vector2D(34, 84))
	
	--Fin de niveau
	createExitZone(levelGrp, Vector2D(35, 494), Vector2D(150, 130)) 
	
	-- Players
	local player1 = initPlayer(1, levelGrp, userCfg.keyConf.player1Keys, Vector2D(50, 312 - playerSize.y))
	playerSetMode(player1, "move")

	local player2 = initPlayer(2, levelGrp, userCfg.keyConf.player2Keys, Vector2D(70, 312 - playerSize.y))
	playerSetMode(player2, "throw")
end
