require("guiLib/buttonControl")

mainMenuNs = mainMenuNs or {}

-- Quit fn
function mainMenuNs.menuQuitFunction()
	popupDialog(mainMenuScreen, "dialogYesNo", _("Do you really want to quit the game ?"),
		function()
			musicStop(fadeTransitionTime / 2)
			myChangeScreen(GetCurrentScreen(), true, "fade", nil, {onHalfFn = function()
																	Quit()
																end})
		end,
		
		function()
		
		end)
end
-- Create screen
mainMenuScreen = CreateScreen("levelMenuScreen", ScreenConfig(screenSize))

-- Quit
mainMenuScreen:RegisterButtonEvent(function() mainMenuNs.menuQuitFunction(); end, "Escape", true)

-- VIP
if canUseVIP then
	mainMenuScreen:RegisterButtonEvent(function() popupDialog(mainMenuScreen, "dialogOk", _("You get the V.I.P. access !"), function() end); canAccessAllLevel = true; end, "P", true)
end

-- Back
local tmp = mainMenuScreen:CreateSprite("back", mainMenuBackTex, Vector2D(0, 0))
tmp:SetZpos(-1000)

-- Deco
local tmp = mainMenuScreen:CreateShapeRectangleSize("rect1", Vector2D(0, 204), Vector2D(screenSize.x, 191), Color(0, 0, 0, 200), 0, Color(0, 0, 0))

local text = mainMenuScreen:CreateText("txt", "Bombe Hunter")
text:SetFont(fontFixedsys)
text:SetSize(170)
text:SetPosition(Vector2D(screenSize.x / 2, 265) - text:GetTextSize() / 2)

-- Version
local text = mainMenuScreen:CreateText("txt", string.format(_("Version : %s"), version))
text:SetFont(fontFixedsys)
text:SetSize(40)
local txtSize = text:GetTextSize()

text:SetPosition(Vector2D(screenSize.x - txtSize.x - 32, 42))
	-- Contour
local margin = Vector2D(10, 10)
local offset = Vector2D(0, 5)
local tmp = mainMenuScreen:CreateShapeRectangle("rect2", text:GetPosition() - margin + offset, text:GetPosition() + offset + txtSize + margin, Color(0, 0, 0, 200), 0, Color(0, 0, 0))
tmp:SetZpos(-10)

-- Info
	-- text
mainMenuNs.noDescription = _("Put your mouse over a button to get its description.")

local tmp = mainMenuScreen:CreateShapeRectangleSize("rect3", Vector2D(29, 436), Vector2D(462, 439), Color(215, 138, 48, 255 * 0.4), 0, Color(0, 0, 0))

local text = mainMenuScreen:CreateText("txtDescription", mainMenuNs.noDescription)
text:SetSize(40)
text:SetFont(fontFixedsys)
text:SetPosition(tmp:GetPointPosition(1) + margin)
text:SetMaxWidth(tmp:GetPointPosition(2).x - tmp:GetPointPosition(1).x - margin.x * 2)

-- Gui
function mainMenuNs.setInfoText(bt, isInside)
	local text = mainMenuScreen:FindByNameText("txtDescription")
	
	if isInside then
		text:SetText(bt:GetUserData("description"))
	else
		text:SetText(mainMenuNs.noDescription)
	end
end

function mainMenuNs.myBtCreate(title, pos, btSize, description, fn)
	local bt = mainMenuScreen:CreateGroup("levelBt")
	buttonControlCreate(bt, title, btSize)
	buttonSetEventFunction(bt, fn)
	buttonSetOverFunction(bt, mainMenuNs.setInfoText)
	buttonSetFont(bt, 34, Color(255, 255, 255), fontFixedsys)
	buttonSetImagePack(bt, texMenuBtNormal, texMenuBtOver, texMenuBtPressed)
	bt:SetPosition(pos)
	bt:SetUserData("description", description)
	
	return bt
end

btSize = texMenuBtNormal:GetSize()
mainMenuNs.myBtCreate(_("Campaign"), Vector2D(630, 510), btSize, _("Begin or continue a Campaign."), function() loadMapFromFile("map1.lua", "campagne"); myChangeScreen(levelMenuScreen, true, "slide1") end)

mainMenuNs.myBtCreate(_("Options"), Vector2D(630, 700), btSize, _("Change the controls, the sound and the graphic options so that they correspond to your needs."), function() myChangeScreen(menuOptionNs.screen, true, "slide1") end)

mainMenuNs.myBtCreate(_("About"), Vector2D(1194, 510), btSize, _("Discover the authers of this game."), function() creditNs.createCreditInfo(); myChangeScreen(creditNs.screen, true, "slide1") end)

local bt = mainMenuNs.myBtCreate(_("Quit"), Vector2D(1194, 700), btSize, _("Quit the game."), function() mainMenuNs.menuQuitFunction(); end)
buttonSetClickSound(bt, sndBtClick)

mainMenuNs.myBtCreate(_("How to play"), Vector2D(1194, 604), btSize, _("Learn how to play."), function() howToPlayNs.createInfo(); myChangeScreen(howToPlayNs.screen, true, "slide1"); end)

mainMenuNs.myBtCreate(_("Challenges"), Vector2D(630, 604), btSize, _("Do the levels again trying to be as fast as possible. You can't die, but the things that would have hurt you make you lose time"),
	function()
		if lvlProgress.isLevelDone(lastLevel, false) or (canAccessAllLevel == true) then -- on doit finir le mode normale
			loadMapFromFile("map1.lua", "challenge")
			myChangeScreen(levelMenuScreen, true, "slide1")
		else
			popupDialog(GetCurrentScreen(), "dialogOk", _("You must finish the Campaign mode to access the Challenge mode !"), function() end, nil)
			soundNs.PlayGlobalSnd(sndLevelNoAccess)
		end
	end)
