------------------------------------------------------------
function beginSight(player)
	endSight(player) -- Clear

	-- Mouse
	local evt = player:GetParentScreen():RegisterMouseMoveEvent(sightNs.privateSightEvent)
	
	evt:SetUserData("player", player)
	
	player:SetUserData("sightEvent", evt)
	guiLib_addAutoDestroyEvent(player, evt)
	
	-- Keyboard
	if userCfg.keyConf.isFakeMouse then
		local evt = player:GetParentScreen():RegisterFrameEvent(sightNs.privateFakeMouseEvent)
		
		evt:SetUserData("player", player)
		
		player:SetUserData("sightFakeMouseEvent", evt)
		guiLib_addAutoDestroyEvent(player, evt)
	end
	
	-- sight group in gameRenderScreen
	local decalgeX = 0
	if player:GetUserData("playerId") == 2 then
		decalgeX = screenSize.x / 2
	end
	
	local sightGroup = gameRenderScreen:CreateGroup("sightGroup", Vector2D(decalgeX + screenSize.x / 4, screenSize.y / 2))
	
	-- Cursor spr
	local spr = sightGroup:CreateSprite("cursorSpr", cursorSightTex, Vector2D(0, 0))
	spr:SetCenter(Vector2D(spr:GetSize().x / 2, 0))

	-- Show
	sightNs.fakeMousePos = Vector2D(0, 0)
	sightNs.privateSightEvent(Vector2D(0, -20), player:GetUserData("sightEvent"))
end
------------------------------------------------------------
function endSight(player)
	if UserDataExistsAndIsNotEqual(player, "sightEvent", nil) then
		local evt = player:GetUserData("sightEvent")
		evt:Destroy()
		guiLib_removeAutoDestroyEvent(player, evt)
		player:SetUserData("sightEvent", nil)
		
		-- Fake mouse
		if UserDataExistsAndIsNotEqual(player, "sightFakeMouseEvent", nil) then
			local evt = player:GetUserData("sightFakeMouseEvent")
			evt:Destroy()
			guiLib_removeAutoDestroyEvent(player, evt)
			player:SetUserData("sightFakeMouseEvent", nil)
		end
		
		-- Sight logo
		local sightGrp = gameRenderScreen:FindByName("sightGroup")
		if sightGrp ~= nil then
			sightGrp:Destroy()
		end
	end
	
	--[[if UserDataExistsAndIsNotEqual(player, "sightLine", nil) then
		player:GetUserData("sightLine"):Destroy()
		player:SetUserData("sightLine", nil)
	end]]
end
------------------------------------------------------------
function getSightInfo(player)
	return player:GetUserData("sightDirection"), player:GetUserData("sightSpeed")
end
------------------------------------------------------------
sightNs = sightNs or {}

sightNs.fakeMousePos = Vector2D(0, 0)
------------------------------------------------------------
function sightNs.cursorMove(mvt, player)
	sightNs.fakeMousePos = sightNs.fakeMousePos + mvt
	
	local size = math.min(sightNs.fakeMousePos:GetSize(), bombeSightMaxDist)
	local direction = sightNs.fakeMousePos:GetDirection()
	local speed = (size / bombeSightMaxDist) * bombeLunchSpeedMax
	
	player:SetUserData("sightDirection", direction)
	player:SetUserData("sightSpeed", speed)
	
	-- Limited pos
	sightNs.fakeMousePos = direction * size
	
	-- sightLine	
	viewPlayerSight(player, size, direction, speed)
	
	-- Trajectoire
	testBombeTrajectoire(player:GetGlobalPosition() + viseurCenterPos, getSightInfo(player))
end
------------------------------------------------------------
function sightNs.privateSightEvent(pos, evt)
	sightNs.cursorMove(pos, evt:GetUserData("player"))
end
------------------------------------------------------------
function sightNs.privateFakeMouseEvent(frameTime, evt)
	local direction = Vector2D(0, 0)
	
	if IsKeyPressed(userCfg.keyConf.fakeMouseKeys["keyRight"]) then
		direction = direction + Vector2D(1, 0)
	elseif IsKeyPressed(userCfg.keyConf.fakeMouseKeys["keyLeft"]) then
		direction = direction + Vector2D(-1, 0)
	end
	
	if IsKeyPressed(userCfg.keyConf.fakeMouseKeys["keyUp"]) then
		direction = direction + Vector2D(0, -1)
	elseif IsKeyPressed(userCfg.keyConf.fakeMouseKeys["keyDown"]) then
		direction = direction + Vector2D(0, 1)
	end
	
	if direction ~= Vector2D(0, 0) then
		sightNs.cursorMove(direction * userCfg.keyConf.fakeMouseSpeed * frameTime, evt:GetUserData("player"))
	end
end
------------------------------------------------------------
